#include<iostream>
#include"rect.h"
#include<stdio.h>
#include<stdlib.h>
#include<ctime>
#include"ezwin.h"
#include<cassert>
#include"position.h"
#include"bitmap.h"
#include"label.h"

using namespace std;

//These are macros needed
# define LEFT 1
# define RIGHT 2
# define UP 3
# define DOWN 4
# define SIZE 1.0

//These are the variables needed.
int i,j,food_number=0,current=1,level_temp,food_x,food_y;
int score=0; //Counts the game score
int GameTime=350;
int level=1;//Displays the level of game which is dependent on speed
int length;
float snake[1000][2],t;
int dir; // Stores Head Direction
bool temp=false,temp_2=true,temp_3=true;
char name,dummy;


//These are windows needed and their positions

SimpleWindow W1("Game Menu",16.0,16.0,Position(3.0,3.0));
SimpleWindow W2("Game Play",16.0,16.0,Position(0.0,0.0));
SimpleWindow W3("High Score",16.0,16.0,Position(3.0,3.0));
SimpleWindow W4("Game Over",16.0,16.0,Position(3.0,3.0));
SimpleWindow W5("Instructions",16.0,16.0,Position(3.0,3.0));
SimpleWindow W6("Options",16.0,16.0,Position(3.0,3.0));
SimpleWindow W7("Read Me",16.0,16.0,Position(3.0,3.0));


//Defining bmp images needed
BitMap SnakeGame(W1);
BitMap PlayGame(W1);
BitMap Options(W1);
BitMap HighScores(W1);
BitMap Instructions(W1);
BitMap Exit_1(W1);
BitMap Exit_2(W4);
BitMap Restart(W4);
BitMap ReadMe(W1);
BitMap Score_1(W2);
BitMap Score_2(W4);
BitMap Food_1(W2);
BitMap Food_2(W2);
BitMap Food_3(W2);
BitMap SnakeHead_1(W2);
BitMap SnakeHead_2(W2);
BitMap SnakeHead_3(W2);
BitMap SnakeHead_4(W2);
BitMap Wall(W2);
BitMap Level(W2);
BitMap Body(W2);
BitMap BackGround_1(W1);
BitMap BackGround_2(W2);
BitMap BackGround_3(W3);
BitMap BackGround_4(W4);
BitMap BackGround_5(W5);
BitMap BackGround_7(W7);
BitMap digit_2(W2);
BitMap digit_4(W4);


int food()
{
 while(temp==false)
 {	
 	srand(time(NULL));
 	food_x=((rand()%13)+1);//Excluding the wall coordinates.
 	food_y=((rand()%13)+1);
	//This is a check for whether the food is not created on snake itself.
	for(i=0;i<length;i++)
	{
		if((snake[i][1]!=food_x) || (snake[i][2]!=food_y))
		{temp=true;}
    	}
    	}
    	temp=false;
    	food_number++;
	if(level!=3)//Constraint on maximum level to be increased.
    	{level=((food_number/15)+1);}//Here level is increased.
    	if(level==1)
	{
    	Food_1.SetPosition(Position(food_x,food_y));
    	Food_1.Draw();
	}
	if(level==2)
	{
    	Food_2.SetPosition(Position(food_x,food_y));
    	Food_2.Draw();
	}
	if(level==3)
	{
    	Food_3.SetPosition(Position(food_x,food_y));
    	Food_3.Draw();
	}
return 0; }

int W4MouseClick(const Position &p)
{
	if (Exit_2.IsInside(p))
	{
			W4.Close();
			W1.Close();
	}
	
}		


int gameover()
{
	
	temp_2=false;
	W2.Close();
	W4.Open();
	//Window W4
	Score_2.Load("Score.xpm");
        assert(Score_2.GetStatus() == BitMapOkay);
        Score_2.SetPosition(Position(6.5, 3.5));//Add Proper position 	
	Restart.Draw();
	Score_2.Draw();
	//highscore(); (this function is not completed yet)
	W4.SetMouseClickCallback(W4MouseClick);
	cout<<"Your Score is "<<score<<endl;
	cout<<"Your Level was"<<level<<endl;
	
return 0;}



int initialization() //Initializes Snake Variables at the start of every game and every level
{
   
   W2.RenderRectangle(Position(1.0,1.0), Position(14.0,14.0), White, false); 
   length = 5;
   snake[0][1] = 9.0;
   snake[0][2] = 9.0;
   dir = RIGHT;
   SnakeHead_2.SetPosition(Position(9.0,9.0));
   SnakeHead_2.Draw();
   for(i=1;i<length;i++)
   {
	t=i;
   	snake[i][1]=9.0-t*SIZE;
	snake[i][2]=9.0;
   	Body.SetPosition(Position(9.0-t*SIZE,9.0));
   	Body.Draw();
   }	

    food();	
    GameTime = GameTime*(1-(level-1)*50);//Minimum Game Delay is 100.
    W2.RenderRectangle(Position(14.0,0.0), Position(15.0,15.0),Red, false);
    W2.RenderRectangle(Position(0.0,0.0), Position(1.0,15.0),Red, false);
    W2.RenderRectangle(Position(0.0,0.0), Position(15.0,1.0),Red, false);
    W2.RenderRectangle(Position(0.0,14.0), Position(15.0,15.0),Red, false);
return 0;
}    
    
int endofgame()//After collision with the walls with coordinates x=0 and x=16,y=0 and y=16.Current code is written without mazes.
{
  
  if(((dir==LEFT)&&(snake[0][1]==1.0))||((dir==RIGHT)&&(snake[0][1]==14.0))||((dir==UP)&&(snake[0][2]==1.0))
     ||((dir==DOWN)&&(snake[0][2]==14.0)))
   {
   	gameover();
   	}  
  for(i=1;i<length;i++)
  {
  	if((snake[0][1]==snake[i][1])&&(snake[0][2]==snake[i][2]))
  	{
  		gameover();
  	 } 
   }
return 0;
}

int movement()
 {
 	
	W2.RenderRectangle(Position(1.0,1.0), Position(14.0,14.0), White, false);   	
	
    for(i=length;i>0;i--)//Swapping the Array Values for Movement
  {
  	
  	snake[i][1]=snake[i-1][1];
  	snake[i][2]=snake[i-1][2]; 
  	if(i==length){continue;}//saving coordinates of the tail before the movt
  	Body.SetPosition(Position(snake[i][1],snake[i][2]));//For redrawing the snake tail
  	Body.Draw();
  }	
	if(level==1)
	{
    	Food_1.SetPosition(Position(food_x,food_y));
    	Food_1.Draw();
	}
	if(level==2)
	{
    	Food_2.SetPosition(Position(food_x,food_y));
    	Food_2.Draw();
	}
	if(level==3)
	{
    	Food_3.SetPosition(Position(food_x,food_y));
    	Food_3.Draw();
	}  

  
  //Moving the Head
  if (dir == LEFT)
    { 
      snake[0][1]=snake[0][1]- SIZE; 
      SnakeHead_1.SetPosition(Position(snake[0][1],snake[0][2]));
  	SnakeHead_1.Draw();//Drawing the New Head Image
    }
  else if (dir == RIGHT) 
    {
      snake[0][1]=snake[0][1] + SIZE; 
	SnakeHead_2.SetPosition(Position(snake[0][1],snake[0][2]));
  	SnakeHead_2.Draw();
    }
  else if(dir == UP) 
    {
      snake[0][2]=snake[0][2]- SIZE;
	SnakeHead_3.SetPosition(Position(snake[0][1],snake[0][2]));
  	SnakeHead_3.Draw();
    }
  else if(dir == DOWN) 
    {
      snake[0][2]=snake[0][2]+ SIZE;
	SnakeHead_4.SetPosition(Position(snake[0][1],snake[0][2]));
  	SnakeHead_4.Draw(); 
    }
    else{} 
            
return 0;}




int scoring()
{
		
		if((snake[0][1]==food_x) && (snake[0][2]==food_y))
		{
		score =score+20+(10*(level-1));//The score here is dependent on level.
		food();//Render Text for the Position Here.
		length++;
		}
return 0;}
	
int highscore()
{
	return 0;
}	


int turn(const Position &p)//This Function is used to change the direction based on mouse click.
{
	if((dir== UP)||(dir==DOWN))
	{
		//if the mouse click is to the left of the snake, then turn left
		if(p.GetXDistance()<snake[0][1])
		{
			dir=LEFT;
		}
		//if the mouse click is to the right of the snake, then turn right
		if(p.GetXDistance()>snake[0][1])
		{
			dir=RIGHT;
		}
		
	}
	//if the direction of the snake is left or right then to change it, following code works:
	else if((dir== LEFT)||(dir==RIGHT) )
	{
		//if the mouse click is above the snake, then turn upwards
		if(p.GetYDistance()<snake[0][2])
		{
			dir=UP;
		}
		//if the mouse click is below the snake, then turn downwards 
		if(p.GetYDistance()>snake[0][2])
		{
			dir=DOWN;
		}
	}
	else{}
	
	return 1;
}

//Game Run function

int gamerun()
{
	
	endofgame();
	scoring();
	movement();
	if(level!=current)
	{current=level;
	initialization();
	}



return 1;
}
//**********************************
int W1MouseClick(const Position &p)
{
//Mouse click Function for opening respective Windows.
	if (PlayGame.IsInside(p))
	{
			W2.Open();
			assert(W2.GetStatus() == WindowOpen);
			//*************************************
			//Window W2
Score_1.Load("Score.xpm");
        assert(Score_1.GetStatus() == BitMapOkay);
        Score_1.SetPosition(Position(1.0,15.0));//Add proper position 

//Window W2
Level.Load("Level.xpm");
        assert(Level.GetStatus() == BitMapOkay);
        Level.SetPosition(Position(7.0,15.0));//Ad                                            

//Window W2
	Food_1.Load("Food[1].xpm");
        assert(Food_1.GetStatus() == 	BitMapOkay);                                                              

//Window W2
	Food_2.Load("Food[2].xpm");
        assert(Food_2.GetStatus() == 	BitMapOkay);                                                              

//Window W2
	Food_3.Load("Food[3].xpm");
        assert(Food_3.GetStatus() == 	BitMapOkay);                                                              


//Window W2
SnakeHead_1.Load("SnakeHead[1].xpm");
        assert(SnakeHead_1.GetStatus() == BitMapOkay);
                 
                              
//Window W2
SnakeHead_2.Load("SnakeHead[2].xpm");
        assert(SnakeHead_2.GetStatus() == BitMapOkay);         

//Window W2
SnakeHead_3.Load("SnakeHead[3].xpm");
        assert(SnakeHead_3.GetStatus() == BitMapOkay);
                 

//Window W2
SnakeHead_4.Load("SnakeHead[4].xpm");
        assert(SnakeHead_4.GetStatus() == BitMapOkay);
                 

//Window W2
	Body.Load("Body.xpm");
        assert(Body.GetStatus() == BitMapOkay);         

//Window W2
Level.Load("Level.xpm");
        assert(Level.GetStatus() == BitMapOkay);

			Score_1.Draw();
			Level.Draw();
			initialization();
			
			
			InitializeSeed();
			W2.SetTimerCallback(gamerun);
			W2.StartTimer(GameTime);
			W2.SetMouseClickCallback(turn);
}

else if(HighScores.IsInside(p))
			{
			W3.Open();
			assert(W3.GetStatus() == WindowOpen);
			//Window W3
			BackGround_3.Load("Background[1].xpm");
        		assert(BackGround_3.GetStatus() == BitMapOkay);
        		BackGround_3.SetPosition(Position(0.0,0.0));              
			BackGround_3.Draw();
			
			W3.RenderText(Position(2.0,2.0),Position(7.0,3.0),"This function has not been completed yet",Red);
			W3.RenderText(Position(7.0,2.0),Position(14.0,3.0),"Enter any letter in terminal to continue",Red);
			cin>>dummy;
			BackGround_3.Erase();
			W3.Close();
			}
			
else if(Instructions.IsInside(p))
			{
			W5.Open();
			//Window W5
			BackGround_5.Load("Background[1].xpm");
        		assert(BackGround_5.GetStatus() == BitMapOkay);
        		BackGround_5.SetPosition(Position(0.0,0.0));              
			BackGround_5.Draw();
			
			assert(W5.GetStatus() == WindowOpen);
			W5.RenderText(Position(0.0,0.0),Position(7.0,3.0),"Enter any letter in terminal to continue",Red);
			cin>>dummy;
			W5.Close();
			}
			
else if(ReadMe.IsInside(p))
			{
			W7.Open();
			//Window W7
			BackGround_7.Load("Background[1].xpm");
        		assert(BackGround_7.GetStatus() == BitMapOkay);
        		BackGround_7.SetPosition(Position(0.0,0.0));              
			BackGround_7.Draw();
			assert(W7.GetStatus() == WindowOpen);
			W7.RenderText(Position(0.0,0.0),Position(7.0,3.0),"Enter any letter in terminal to continue",Red);
			cin>>dummy;
			W7.Close();
			}
			
else if(Exit_1.IsInside(p))
			{W1.Close();}
			

else{}
return 0;//Error
}

//******************************************************************************


int ApiMain()
{
	cout<<"Enter your First Name!!!!!\n";
	cin>>name;
	//for(i=0;i<3;i++){score_digit[i]=0;}
	W1.Open();
	assert(W1.GetStatus() == WindowOpen);
	

//Image loading on opening the Respective Windows

//Window W1
BackGround_1.Load("Background[1].xpm");
        assert(BackGround_1.GetStatus() == BitMapOkay);
        BackGround_1.SetPosition(Position(0.0,0.0));              
	BackGround_1.Draw();

//Window W1
SnakeGame.Load("SnakeGame.xpm");
        assert(SnakeGame.GetStatus() == BitMapOkay);
        SnakeGame.SetPosition(Position(1.0,1.0));
        SnakeGame.Draw();              

//Window W1
PlayGame.Load("PlayGame.xpm");
        assert(PlayGame.GetStatus() == BitMapOkay);
        PlayGame.SetPosition(Position(1.0,5.0));
        PlayGame.Draw();                           
                
        
//Window W1
HighScores.Load("HighScores.xpm");
        assert(HighScores.GetStatus() == BitMapOkay);
        HighScores.SetPosition(Position(1.0,11.0));             	
	HighScores.Draw();                     
        
        
//Window W1
Instructions.Load("Instructions.xpm");
        assert(Instructions.GetStatus() == BitMapOkay);
        Instructions.SetPosition(Position(1.0,7.0));              
	Instructions.Draw();
	       
        
//Window W1
Exit_1.Load("Exit.xpm");
        assert(Exit_1.GetStatus() == BitMapOkay);
        Exit_1.SetPosition(Position(1.0,13.0));
	Exit_1.Draw();                                  
        
        
//Window W1
ReadMe.Load("ReadMe.xpm");
        assert(ReadMe.GetStatus() == BitMapOkay);
        ReadMe.SetPosition(Position(1.0,9.0));              
	ReadMe.Draw();                                
                                
W1.SetMouseClickCallback(W1MouseClick);

return 0;
}



